VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsUndo"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

'-----------------------------
'ygz
' OƂāA
' (1) ΏۂƂȂtH[ (declarations) ZNVŁANXEIuWFNg錾B
'         Dim undoMain As New clsUndo
' (2) ΏۂƂȂtH[ Form_Load vV[WŁAsȂB
'         Call undoMain.Initialize(100, Text1)
' (3) Undo LɂeRg[ieeLXg{bNXȂǁjɂāA
'     ȉ̃vV[Włꂼ֐Ȃǂs悤AR[hd|ĂB
'         CONTROLNAME_Change    Call undoMain.Add(CONTROLNAME)
'         CONTROLNAME_GotFocus  Call undoMain.ReNew(ActiveControl)
'         CONTROLNAME_KeyUp     Call undoMain.ReNew(ActiveControl)
'         CONTROLNAME_MouseUp   Call undoMain.ReNew(ActiveControl)
'-----------------------------
' Note : CONTROLNAME_Change() ɊւẮARg[̒lωƂA
'        ɂ̃Rg[ active ɂȂĂƂ͌ȂB
'        iႦ΁Ac[o[ɂ鑀ȂǁBj
'        ]āAƂēn̂ ActiveControl ł͂ȂARg[głȂĂ
'        ȂȂB
'-----------------------------

Private Type UndoContainer
    Obj As Object
    Text As String
    SelStart As Long
End Type

Dim undoHistory() As UndoContainer
Dim undoBuffer As UndoContainer

Dim lngIndex As Long
Dim boolUndoing As Boolean


'=====================================================================
' Rg[lύXAȂǂ̗RŁAUndo VKɒǉB
'---------------------------------------------------------------------
'  : objTarget : l̕ύXꂽRg[
'---------------------------------------------------------------------
' ߂l : True  : ۂɗւ̒ǉNB
'          False : Undoing tOĂȂǂ̗Rŏ𒆒fB
'---------------------------------------------------------------------
Public Function Add(objTarget As Object) As Boolean

    On Error GoTo ErrorHandler

    Dim lngI As Long
    Dim lngDecrementStep As Long
    
    ' Undoing tOĂȂ΁AFalse ԂĔB
    If boolUndoing Then GoTo ErrorHandler

    ' nꂽRg[ƁAݍŐṼ̗Rg[Ƃʕ̏ꍇA
    If Not objTarget Is undoHistory(lngIndex).Obj Then
        lngDecrementStep = 2
    Else
        lngDecrementStep = 1
    End If
    
    ' ɍő index ܂ŗĂꍇ́A
    If lngIndex = UBound(undoHistory) Then
        ' vfɑOւ炷B
        For lngI = 0 To UBound(undoHistory) - lngDecrementStep
            Set undoHistory(lngI).Obj = undoHistory(lngI + lngDecrementStep).Obj
            undoHistory(lngI).Text = undoHistory(lngI + lngDecrementStep).Text
            undoHistory(lngI).SelStart = undoHistory(lngI + lngDecrementStep).SelStart
        Next lngI
        lngIndex = lngIndex - lngDecrementStep
    End If
    
    ' nꂽRg[ƁAݍŐṼ̗Rg[Ƃʕ̏ꍇA
    If Not objTarget Is undoHistory(lngIndex).Obj Then
        lngIndex = lngIndex + 1
        Set undoHistory(lngIndex).Obj = undoBuffer.Obj
        undoHistory(lngIndex).Text = undoBuffer.Text
        undoHistory(lngIndex).SelStart = undoBuffer.SelStart
    End If
    
    lngIndex = lngIndex + 1
    Set undoHistory(lngIndex).Obj = objTarget
    undoHistory(lngIndex).Text = objTarget.Text
    undoHistory(lngIndex).SelStart = objTarget.SelStart

    ' V Undo Ƀf[^Ăꍇ́A폜B
    If lngIndex < UBound(undoHistory) Then
        lngI = lngIndex
        Do
            lngI = lngI + 1
            If lngI > UBound(undoHistory) Then
                Exit Do
            ElseIf undoHistory(lngI).Obj Is Nothing Then
                Exit Do
            Else
                Call ClearIndex(lngI)
            End If
        Loop
    End If

    Add = True  ' ߂lݒB

    Exit Function

ErrorHandler:
    Add = False

End Function


'=====================================================================
' Undo ƃobt@ɂLȗvfɂāÃRg[SďB
'---------------------------------------------------------------------
'  : objTarget   : ̃Rg[
'---------------------------------------------------------------------
Public Sub ChangeObject( _
    objTarget)

    On Error GoTo ErrorHandler

    Dim lngI As Long

    ' obt@
    If Not undoBuffer.Obj Is Nothing Then
        Set undoBuffer.Obj = objTarget
    End If
    
    ' Undo 
    For lngI = 0 To UBound(undoHistory)
        If undoHistory(lngI).Obj Is Nothing Then
            Exit For
        Else
            Set undoHistory(lngI).Obj = objTarget
        End If
    Next lngI

ErrorHandler:

End Sub


'=====================================================================
' Undo SċɂAIndex, Undoing vpeBB
'---------------------------------------------------------------------
'  : objTarget   : 擪 index Ɋi[Rg[
'        varText     : objTarget ̏lBȗꍇ́A󕶎񂪓B
'        varSelStart : objTarget ł̃J[\ʒuBȗꍇ́A0 B
'---------------------------------------------------------------------
Public Sub Clear( _
    objTarget As Object, _
    Optional ByVal varText As Variant, Optional ByVal varSelStart As Variant)

    On Error GoTo ErrorHandler

    Dim lngI As Long
    
    If IsMissing(varText) Then varText = ""
    If IsMissing(varSelStart) Then varSelStart = 0
    
    lngIndex = 0
    boolUndoing = False
    
    Set undoHistory(0).Obj = objTarget
    undoHistory(0).Text = varText
    undoHistory(0).SelStart = varSelStart
    
    For lngI = 1 To UBound(undoHistory)
        If undoHistory(lngI).Obj Is Nothing Then Exit For
        Call ClearIndex(lngI)
    Next lngI

ErrorHandler:

End Sub


'=====================================================================
' w肳ꂽ index ̃R[hB
'---------------------------------------------------------------------
'  : lngI :  index ԍ
'---------------------------------------------------------------------
Private Sub ClearIndex(lngI As Long)

    On Error GoTo ErrorHandler

    Set undoHistory(lngI).Obj = Nothing
    undoHistory(lngI).Text = ""
    undoHistory(lngI).SelStart = 0

ErrorHandler:

End Sub


'=====================================================================
' w肳ꂽő嗚𐔂悤B
'---------------------------------------------------------------------
'  : Max         : ő嗚
'        objTarget   : 擪 index Ɋi[Rg[
'        varText     : objTarget ̏lBȗꍇ́A󕶎񂪓B
'        varSelStart : objTarget ł̃J[\ʒuBȗꍇ́A0 B
'---------------------------------------------------------------------
Public Sub Initialize( _
    Max As Long, objTarget As Object, _
    Optional ByVal varText As Variant, Optional ByVal varSelStart As Variant)
    
    On Error GoTo ErrorHandler
    
    ReDim undoHistory(0 To Max - 1)
    
    Call Clear(objTarget, varText, varSelStart)

ErrorHandler:

End Sub


'=====================================================================
' Redo B
'---------------------------------------------------------------------
' ߂l : Redo ̌ʁAANeBuɂȂIuWFNgB
'---------------------------------------------------------------------
Public Function Redo() As Object

    On Error GoTo ErrorHandler

    ' Redo ׂڂARedo s̏ԂȂ΁AɔB
    If Redoable = False Then
        Set Redo = Nothing:  Exit Function
    End If

    boolUndoing = True          ' tO𗧂āA
    lngIndex = lngIndex + 1  ' 𒆂 index ₵A
    
    If undoHistory(lngIndex).Obj.Enabled Then  ' \Ȃ΁AtH[JX^B
        undoHistory(lngIndex).Obj.SetFocus
    End If
    If undoHistory(lngIndex).Obj.Locked = False Then  ' Locked ĂȂȂ΁A
        undoHistory(lngIndex).Obj.Text = undoHistory(lngIndex).Text
        undoHistory(lngIndex).Obj.SelStart = undoHistory(lngIndex).SelStart
    End If
    
    boolUndoing = False  ' tO߂B

    Set Redo = undoHistory(lngIndex).Obj
    
    Exit Function

ErrorHandler:
    Set Redo = Nothing

End Function


'=====================================================================
'  Redo ׂe邩ۂԂ\bhB
'---------------------------------------------------------------------
Property Get Redoable() As Boolean

    On Error GoTo ErrorHandler

    ' Redo ׂڂȂ΁AɔB
    If lngIndex = UBound(undoHistory) Then
        Redoable = False
    ElseIf undoHistory(lngIndex + 1).Obj Is Nothing Then
        Redoable = False
    ' 邢́AUndo ʂƂďׂRg[gpsɂȂĂꍇB
    ElseIf undoHistory(lngIndex + 1).Obj.Locked = True Then
        Redoable = False
    Else
        Redoable = True
    End If

    Exit Property

ErrorHandler:
    Redoable = False

End Property


'=====================================================================
' IuWFNgւ̎QƂ󂯎Ał̒l𗚗Ɋ܂߂B
' IuWFNgVKɃtH[JXlA邢
' {bNXŃJ[\ړAȂǂ̏ꍇɌĂяoB
'---------------------------------------------------------------------
'  : objTarget : Ώۂ̃IuWFNg
'---------------------------------------------------------------------
Public Function ReNew(objTarget As Object) As Boolean

    On Error GoTo ErrorHandler

    ' Undoing tOĂȂ΁AɔB
    If boolUndoing Then GoTo ErrorHandler

    ' nꂽRg[̏Aobt@ɓB
    Set undoBuffer.Obj = objTarget
    undoBuffer.Text = objTarget.Text
    undoBuffer.SelStart = objTarget.SelStart

    ReNew = True  ' ߂lݒ肵āA֐𔲂B

    Exit Function

ErrorHandler:
    
    ReNew = False
    
End Function


'=====================================================================
' fobOp֐
'---------------------------------------------------------------------
Public Sub ShowIndex()

    On Error GoTo ErrorHandler

    Dim lngI As Long
    Dim strBuffer As String
    
    Debug.Print "-----------"
    For lngI = 0 To 5
        strBuffer = TypeName(undoHistory(lngI).Obj) & " / " & _
                    undoHistory(lngI).Text & " / " & undoHistory(lngI).SelStart
        If lngI = lngIndex Then strBuffer = strBuffer & " (*)"
        Debug.Print strBuffer
    Next lngI

ErrorHandler:

End Sub


'=====================================================================
' Undo B
'---------------------------------------------------------------------
' ߂l : Undo ̌ʁAANeBuɂȂIuWFNgB
'---------------------------------------------------------------------
Public Function Undo() As Object

    On Error GoTo ErrorHandler
    
    ' Undo ׂڂAUndo s̏ԂȂ΁AɔB
    If Undoable = False Then
        Set Undo = Nothing:  Exit Function
    End If

    boolUndoing = True          ' tO𗧂āA
    lngIndex = lngIndex - 1  ' 𒆂 index ߂A
    
    If undoHistory(lngIndex).Obj.Enabled Then  ' Enabled Ȃ΁A
        undoHistory(lngIndex).Obj.SetFocus
    End If
    If undoHistory(lngIndex).Obj.Locked = False Then  ' Locked ĂȂȂ΁A
        undoHistory(lngIndex).Obj.Text = undoHistory(lngIndex).Text
        undoHistory(lngIndex).Obj.SelStart = undoHistory(lngIndex).SelStart
    End If
    
    boolUndoing = False  ' tO߂B

    Set Undo = undoHistory(lngIndex).Obj
    
    Exit Function

ErrorHandler:
    Set Undo = Nothing

End Function


'=====================================================================
'  Undo ׂe邩ۂԂ\bhB
'---------------------------------------------------------------------
Property Get Undoable() As Boolean

    On Error GoTo ErrorHandler

    Dim lngI As Long

    lngI = lngIndex
    If undoHistory(lngIndex).Obj Is Nothing Then lngI = lngI - 1

    ' Undo ׂڂȂ΁AFalse ԂB
    If lngI <= 0 Then
        Undoable = False
    ' Undo ׂڂɂȂĂꍇAFalse ԂB
    ElseIf undoHistory(lngI - 1).Obj Is Nothing Then
        Undoable = False
    ' 邢́AUndo ʂƂďׂRg[bNĂꍇ FalseB
    ElseIf undoHistory(lngI - 1).Obj.Locked = True Then
        Undoable = False
    Else
        Undoable = True
    End If
    
    Exit Property
    
ErrorHandler:
    Undoable = False
    
End Property


'=====================================================================
' Undo łEȂIɏB
'---------------------------------------------------------------------
Property Let Undoing(boolValue As Boolean)

    boolUndoing = boolValue

End Property

